package com.qxgmat.data.dao.entity;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.*;

@Table(name = "textbook_paper")
public class TextbookPaper implements Serializable {
    @Id
    @Column(name = "`id`")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 年份
     */
    @Column(name = "`year`")
    private Integer year;

    /**
     * 组卷逻辑：ps、ds、ps+ds
     */
    @Column(name = "`logic`")
    private String logic;

    /**
     * 换库id
     */
    @Column(name = "`set_id`")
    private Integer setId;

    /**
     * 题目编号ids：json
     */
    @Column(name = "`question_no_ids`")
    private Integer[] questionNoIds;

    @Column(name = "`question_number`")
    private Integer questionNumber;

    @Column(name = "`create_time`")
    private Date createTime;

    private static final long serialVersionUID = 1L;

    /**
     * @return id
     */
    public Integer getId() {
        return id;
    }

    /**
     * @param id
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 获取年份
     *
     * @return year - 年份
     */
    public Integer getYear() {
        return year;
    }

    /**
     * 设置年份
     *
     * @param year 年份
     */
    public void setYear(Integer year) {
        this.year = year;
    }

    /**
     * 获取组卷逻辑：ps、ds、ps+ds
     *
     * @return logic - 组卷逻辑：ps、ds、ps+ds
     */
    public String getLogic() {
        return logic;
    }

    /**
     * 设置组卷逻辑：ps、ds、ps+ds
     *
     * @param logic 组卷逻辑：ps、ds、ps+ds
     */
    public void setLogic(String logic) {
        this.logic = logic;
    }

    /**
     * 获取换库id
     *
     * @return set_id - 换库id
     */
    public Integer getSetId() {
        return setId;
    }

    /**
     * 设置换库id
     *
     * @param setId 换库id
     */
    public void setSetId(Integer setId) {
        this.setId = setId;
    }

    /**
     * 获取题目编号ids：json
     *
     * @return question_no_ids - 题目编号ids：json
     */
    public Integer[] getQuestionNoIds() {
        return questionNoIds;
    }

    /**
     * 设置题目编号ids：json
     *
     * @param questionNoIds 题目编号ids：json
     */
    public void setQuestionNoIds(Integer[] questionNoIds) {
        this.questionNoIds = questionNoIds;
    }

    /**
     * @return question_number
     */
    public Integer getQuestionNumber() {
        return questionNumber;
    }

    /**
     * @param questionNumber
     */
    public void setQuestionNumber(Integer questionNumber) {
        this.questionNumber = questionNumber;
    }

    /**
     * @return create_time
     */
    public Date getCreateTime() {
        return createTime;
    }

    /**
     * @param createTime
     */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", year=").append(year);
        sb.append(", logic=").append(logic);
        sb.append(", setId=").append(setId);
        sb.append(", questionNoIds=").append(questionNoIds);
        sb.append(", questionNumber=").append(questionNumber);
        sb.append(", createTime=").append(createTime);
        sb.append("]");
        return sb.toString();
    }

    public static TextbookPaper.Builder builder() {
        return new TextbookPaper.Builder();
    }

    public static class Builder {
        private TextbookPaper obj;

        public Builder() {
            this.obj = new TextbookPaper();
        }

        /**
         * @param id
         */
        public Builder id(Integer id) {
            obj.setId(id);
            return this;
        }

        /**
         * 设置年份
         *
         * @param year 年份
         */
        public Builder year(Integer year) {
            obj.setYear(year);
            return this;
        }

        /**
         * 设置组卷逻辑：ps、ds、ps+ds
         *
         * @param logic 组卷逻辑：ps、ds、ps+ds
         */
        public Builder logic(String logic) {
            obj.setLogic(logic);
            return this;
        }

        /**
         * 设置换库id
         *
         * @param setId 换库id
         */
        public Builder setId(Integer setId) {
            obj.setSetId(setId);
            return this;
        }

        /**
         * 设置题目编号ids：json
         *
         * @param questionNoIds 题目编号ids：json
         */
        public Builder questionNoIds(Integer[] questionNoIds) {
            obj.setQuestionNoIds(questionNoIds);
            return this;
        }

        /**
         * @param questionNumber
         */
        public Builder questionNumber(Integer questionNumber) {
            obj.setQuestionNumber(questionNumber);
            return this;
        }

        /**
         * @param createTime
         */
        public Builder createTime(Date createTime) {
            obj.setCreateTime(createTime);
            return this;
        }

        public TextbookPaper build() {
            return this.obj;
        }
    }
}