package com.qxgmat.data.dao.entity;

import java.io.Serializable;
import javax.persistence.*;

@Table(name = "textbook_question")
public class TextbookQuestion implements Serializable {
    @Id
    @Column(name = "`id`")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 题目编号：人工
     */
    @Column(name = "`title`")
    private String title;

    /**
     * 题目序号
     */
    @Column(name = "`no`")
    private Integer no;

    /**
     * 机经版本：关联换库表
     */
    @Column(name = "`set_id`")
    private Integer setId;

    /**
     * 题目id
     */
    @Column(name = "`question_id`")
    private Integer questionId;

    /**
     * 题型
     */
    @Column(name = "`question_type`")
    private String questionType;

    /**
     * 总做题时间
     */
    @Column(name = "`total_time`")
    private Integer totalTime;

    /**
     * 总做题次数
     */
    @Column(name = "`total_number`")
    private Integer totalNumber;

    /**
     * 总正确次数
     */
    @Column(name = "`total_correct`")
    private Integer totalCorrect;

    /**
     * 自定义题目：0为基础题，组卷，1自定义题，不组卷
     */
    @Column(name = "`is_custom`")
    private Integer isCustom;

    private static final long serialVersionUID = 1L;

    /**
     * @return id
     */
    public Integer getId() {
        return id;
    }

    /**
     * @param id
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 获取题目编号：人工
     *
     * @return title - 题目编号：人工
     */
    public String getTitle() {
        return title;
    }

    /**
     * 设置题目编号：人工
     *
     * @param title 题目编号：人工
     */
    public void setTitle(String title) {
        this.title = title;
    }

    /**
     * 获取题目序号
     *
     * @return no - 题目序号
     */
    public Integer getNo() {
        return no;
    }

    /**
     * 设置题目序号
     *
     * @param no 题目序号
     */
    public void setNo(Integer no) {
        this.no = no;
    }

    /**
     * 获取机经版本：关联换库表
     *
     * @return set_id - 机经版本：关联换库表
     */
    public Integer getSetId() {
        return setId;
    }

    /**
     * 设置机经版本：关联换库表
     *
     * @param setId 机经版本：关联换库表
     */
    public void setSetId(Integer setId) {
        this.setId = setId;
    }

    /**
     * 获取题目id
     *
     * @return question_id - 题目id
     */
    public Integer getQuestionId() {
        return questionId;
    }

    /**
     * 设置题目id
     *
     * @param questionId 题目id
     */
    public void setQuestionId(Integer questionId) {
        this.questionId = questionId;
    }

    /**
     * 获取题型
     *
     * @return question_type - 题型
     */
    public String getQuestionType() {
        return questionType;
    }

    /**
     * 设置题型
     *
     * @param questionType 题型
     */
    public void setQuestionType(String questionType) {
        this.questionType = questionType;
    }

    /**
     * 获取总做题时间
     *
     * @return total_time - 总做题时间
     */
    public Integer getTotalTime() {
        return totalTime;
    }

    /**
     * 设置总做题时间
     *
     * @param totalTime 总做题时间
     */
    public void setTotalTime(Integer totalTime) {
        this.totalTime = totalTime;
    }

    /**
     * 获取总做题次数
     *
     * @return total_number - 总做题次数
     */
    public Integer getTotalNumber() {
        return totalNumber;
    }

    /**
     * 设置总做题次数
     *
     * @param totalNumber 总做题次数
     */
    public void setTotalNumber(Integer totalNumber) {
        this.totalNumber = totalNumber;
    }

    /**
     * 获取总正确次数
     *
     * @return total_correct - 总正确次数
     */
    public Integer getTotalCorrect() {
        return totalCorrect;
    }

    /**
     * 设置总正确次数
     *
     * @param totalCorrect 总正确次数
     */
    public void setTotalCorrect(Integer totalCorrect) {
        this.totalCorrect = totalCorrect;
    }

    /**
     * 获取自定义题目：0为基础题，组卷，1自定义题，不组卷
     *
     * @return is_custom - 自定义题目：0为基础题，组卷，1自定义题，不组卷
     */
    public Integer getIsCustom() {
        return isCustom;
    }

    /**
     * 设置自定义题目：0为基础题，组卷，1自定义题，不组卷
     *
     * @param isCustom 自定义题目：0为基础题，组卷，1自定义题，不组卷
     */
    public void setIsCustom(Integer isCustom) {
        this.isCustom = isCustom;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", title=").append(title);
        sb.append(", no=").append(no);
        sb.append(", setId=").append(setId);
        sb.append(", questionId=").append(questionId);
        sb.append(", questionType=").append(questionType);
        sb.append(", totalTime=").append(totalTime);
        sb.append(", totalNumber=").append(totalNumber);
        sb.append(", totalCorrect=").append(totalCorrect);
        sb.append(", isCustom=").append(isCustom);
        sb.append("]");
        return sb.toString();
    }

    public static TextbookQuestion.Builder builder() {
        return new TextbookQuestion.Builder();
    }

    public static class Builder {
        private TextbookQuestion obj;

        public Builder() {
            this.obj = new TextbookQuestion();
        }

        /**
         * @param id
         */
        public Builder id(Integer id) {
            obj.setId(id);
            return this;
        }

        /**
         * 设置题目编号：人工
         *
         * @param title 题目编号：人工
         */
        public Builder title(String title) {
            obj.setTitle(title);
            return this;
        }

        /**
         * 设置题目序号
         *
         * @param no 题目序号
         */
        public Builder no(Integer no) {
            obj.setNo(no);
            return this;
        }

        /**
         * 设置机经版本：关联换库表
         *
         * @param setId 机经版本：关联换库表
         */
        public Builder setId(Integer setId) {
            obj.setSetId(setId);
            return this;
        }

        /**
         * 设置题目id
         *
         * @param questionId 题目id
         */
        public Builder questionId(Integer questionId) {
            obj.setQuestionId(questionId);
            return this;
        }

        /**
         * 设置题型
         *
         * @param questionType 题型
         */
        public Builder questionType(String questionType) {
            obj.setQuestionType(questionType);
            return this;
        }

        /**
         * 设置总做题时间
         *
         * @param totalTime 总做题时间
         */
        public Builder totalTime(Integer totalTime) {
            obj.setTotalTime(totalTime);
            return this;
        }

        /**
         * 设置总做题次数
         *
         * @param totalNumber 总做题次数
         */
        public Builder totalNumber(Integer totalNumber) {
            obj.setTotalNumber(totalNumber);
            return this;
        }

        /**
         * 设置总正确次数
         *
         * @param totalCorrect 总正确次数
         */
        public Builder totalCorrect(Integer totalCorrect) {
            obj.setTotalCorrect(totalCorrect);
            return this;
        }

        /**
         * 设置自定义题目：0为基础题，组卷，1自定义题，不组卷
         *
         * @param isCustom 自定义题目：0为基础题，组卷，1自定义题，不组卷
         */
        public Builder isCustom(Integer isCustom) {
            obj.setIsCustom(isCustom);
            return this;
        }

        public TextbookQuestion build() {
            return this.obj;
        }
    }
}