package com.qxgmat.data.dao.entity;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.*;

@Table(name = "user_pay")
public class UserPay implements Serializable {
    @Id
    @Column(name = "`id`")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 用户id
     */
    @Column(name = "`user_id`")
    private Integer userId;

    /**
     * 模块
     */
    @Column(name = "`module`")
    private String module;

    /**
     * 模块扩展信息
     */
    @Column(name = "`module_extend`")
    private String moduleExtend;

    @Column(name = "`create_time`")
    private Date createTime;

    /**
     * 使用状态：0未使用，1已使用
     */
    @Column(name = "`is_use`")
    private Integer isUse;

    /**
     * 使用时间
     */
    @Column(name = "`use_time`")
    private Date useTime;

    @Column(name = "`start_time`")
    private Date startTime;

    @Column(name = "`expire_time`")
    private Date expireTime;

    private static final long serialVersionUID = 1L;

    /**
     * @return id
     */
    public Integer getId() {
        return id;
    }

    /**
     * @param id
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 获取用户id
     *
     * @return user_id - 用户id
     */
    public Integer getUserId() {
        return userId;
    }

    /**
     * 设置用户id
     *
     * @param userId 用户id
     */
    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    /**
     * 获取模块
     *
     * @return module - 模块
     */
    public String getModule() {
        return module;
    }

    /**
     * 设置模块
     *
     * @param module 模块
     */
    public void setModule(String module) {
        this.module = module;
    }

    /**
     * 获取模块扩展信息
     *
     * @return module_extend - 模块扩展信息
     */
    public String getModuleExtend() {
        return moduleExtend;
    }

    /**
     * 设置模块扩展信息
     *
     * @param moduleExtend 模块扩展信息
     */
    public void setModuleExtend(String moduleExtend) {
        this.moduleExtend = moduleExtend;
    }

    /**
     * @return create_time
     */
    public Date getCreateTime() {
        return createTime;
    }

    /**
     * @param createTime
     */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    /**
     * 获取使用状态：0未使用，1已使用
     *
     * @return is_use - 使用状态：0未使用，1已使用
     */
    public Integer getIsUse() {
        return isUse;
    }

    /**
     * 设置使用状态：0未使用，1已使用
     *
     * @param isUse 使用状态：0未使用，1已使用
     */
    public void setIsUse(Integer isUse) {
        this.isUse = isUse;
    }

    /**
     * 获取使用时间
     *
     * @return use_time - 使用时间
     */
    public Date getUseTime() {
        return useTime;
    }

    /**
     * 设置使用时间
     *
     * @param useTime 使用时间
     */
    public void setUseTime(Date useTime) {
        this.useTime = useTime;
    }

    /**
     * @return start_time
     */
    public Date getStartTime() {
        return startTime;
    }

    /**
     * @param startTime
     */
    public void setStartTime(Date startTime) {
        this.startTime = startTime;
    }

    /**
     * @return expire_time
     */
    public Date getExpireTime() {
        return expireTime;
    }

    /**
     * @param expireTime
     */
    public void setExpireTime(Date expireTime) {
        this.expireTime = expireTime;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", userId=").append(userId);
        sb.append(", module=").append(module);
        sb.append(", moduleExtend=").append(moduleExtend);
        sb.append(", createTime=").append(createTime);
        sb.append(", isUse=").append(isUse);
        sb.append(", useTime=").append(useTime);
        sb.append(", startTime=").append(startTime);
        sb.append(", expireTime=").append(expireTime);
        sb.append("]");
        return sb.toString();
    }

    public static UserPay.Builder builder() {
        return new UserPay.Builder();
    }

    public static class Builder {
        private UserPay obj;

        public Builder() {
            this.obj = new UserPay();
        }

        /**
         * @param id
         */
        public Builder id(Integer id) {
            obj.setId(id);
            return this;
        }

        /**
         * 设置用户id
         *
         * @param userId 用户id
         */
        public Builder userId(Integer userId) {
            obj.setUserId(userId);
            return this;
        }

        /**
         * 设置模块
         *
         * @param module 模块
         */
        public Builder module(String module) {
            obj.setModule(module);
            return this;
        }

        /**
         * 设置模块扩展信息
         *
         * @param moduleExtend 模块扩展信息
         */
        public Builder moduleExtend(String moduleExtend) {
            obj.setModuleExtend(moduleExtend);
            return this;
        }

        /**
         * @param createTime
         */
        public Builder createTime(Date createTime) {
            obj.setCreateTime(createTime);
            return this;
        }

        /**
         * 设置使用状态：0未使用，1已使用
         *
         * @param isUse 使用状态：0未使用，1已使用
         */
        public Builder isUse(Integer isUse) {
            obj.setIsUse(isUse);
            return this;
        }

        /**
         * 设置使用时间
         *
         * @param useTime 使用时间
         */
        public Builder useTime(Date useTime) {
            obj.setUseTime(useTime);
            return this;
        }

        /**
         * @param startTime
         */
        public Builder startTime(Date startTime) {
            obj.setStartTime(startTime);
            return this;
        }

        /**
         * @param expireTime
         */
        public Builder expireTime(Date expireTime) {
            obj.setExpireTime(expireTime);
            return this;
        }

        public UserPay build() {
            return this.obj;
        }
    }
}